﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Map;

namespace DrawPolygonByMouseClick
{
	public partial class MainPage : UserControl
	{
        private MapPolyline polyline;

		public MainPage()
		{
			InitializeComponent();
		}

		private void MapMouseClick(object sender, Telerik.Windows.Controls.Map.MapMouseRoutedEventArgs eventArgs)
		{
			Location clicked = eventArgs.Location;
			if (this.polyline == null)
			{
                this.polyline = new MapPolyline()
                {
                    Points = new LocationCollection(),
                    Fill = new SolidColorBrush(Color.FromArgb(90, 0, 0, 255)),
                    Stroke = new SolidColorBrush(Colors.Blue),
                    StrokeThickness = 2
                };

                this.informationLayer.Items.Add(this.polyline);

                polyline.Points.Add(eventArgs.Location);
            }

            polyline.Points.Insert(polyline.Points.Count - 1, eventArgs.Location);

            this.radMap.CaptureMouse();
        }

        private void MapMouseDoubleClick(object sender, MapMouseRoutedEventArgs eventArgs)
        {
            if (this.polyline != null && this.polyline.Points.Count > 2)
            {
                this.polyline.Points.Add(this.polyline.Points[0]);
                var polygon = new MapPolygon()
                {
                    Points = this.polyline.Points,
                    Fill = new SolidColorBrush(Color.FromArgb(90, 0, 0, 255)),
                    Stroke = new SolidColorBrush(Colors.Brown),
                    StrokeThickness = 2
                };

                this.informationLayer.Items.Remove(this.polyline);
                this.polyline = null;
                this.informationLayer.Items.Add(polygon);

                this.radMap.ReleaseMouseCapture();
            }
        }

        private void MouseMove(object sender, MouseEventArgs e)
        {
            if (this.polyline != null && this.polyline.Points.Count > 1)
            {
                var location = Location.GetCoordinates(this.radMap, e.GetPosition(this.radMap));
                this.polyline.Points[this.polyline.Points.Count - 1] = location;
            }
        }
	}
}
